.export sinusweep
.import sine4011
.proc sinusweep
pos1 = $09
pos2 = $0A
pos3 = $0B
freq0 = $0C
freq1 = $0D
freq2 = $0E
freq3 = $0F

  ldx #0
  stx pos2
  stx freq0
  stx freq1
  stx freq3
  lda #$40
  sta freq2

  ; add frequency to position
more:
  lda freq1
  asl a
  lda freq2
  adc pos2
  sta pos2
  txa
  adc freq3
  tax
  lda sine4011,x
  sta $4011

  ; increase frequency logarithmically
  clc
  lda freq2
  adc freq0
  sta freq0
  lda freq3
  adc freq1
  sta freq1
  lda #0
  adc freq2
  sta freq2
  lda #0
  adc freq3
  sta freq3
  bpl more
  rts
.endproc

.if 0
.rodata
.align 256
tri4011:
  .repeat 128, I
    .byte I
  .endrepeat
  .repeat 128, I
    .byte 127-I
  .endrepeat
.endif